import org.junit.Assert;
import org.junit.Test;

public class MySetTest {

    @Test
    public void addTest() {
        //given
        Integer [] numbers = {1, 2, 3};
        MySet <Integer> mySet = new MySet<Integer>(numbers);
        int expected = 3;
        //when
        mySet.add(1);
        mySet.add(1);
        int actual = mySet.size();
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest() {
        //given
        Integer [] numbers = {1, 2, 3};
        MySet <Integer> mySet = new MySet<>(numbers);
        mySet.add(1);
        mySet.add(2);
        mySet.add(4);
        int expected = 4;
        //when
        int actual = mySet.get(3);
        //then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void clearTest() {
        //given
        Integer [] numbers = {1, 2, 3};
        MySet<Integer> mySet = new MySet<>(numbers);
        //when
        mySet.clear();
        //then
        Assert.assertNull(numbers[1]);
    }

    @Test
    public void isEmptyTest() {
        //given
        String [] words = {"Hopefully", "I'm", "doing", "this", "right"};
        MySet<String> wordSet = new MySet<>(words);
        //when
        boolean actual = wordSet.isEmpty();
        //then
        Assert.assertFalse(actual);
    }

    @Test
    public void isEmptyTest2() {
        //given
        String [] noWords = {};
        MySet<String> wordSet = new MySet<>(noWords);
        //when
        boolean actual = wordSet.isEmpty();
        //then
        Assert.assertTrue(actual);
    }

    @Test
    public void containsTest() {
        //given
        Integer [] numbers = {1, 3, 6, 15, 25};
        MySet<Integer> numSet = new MySet<>(numbers);
        //when
        boolean actual = numSet.contains(25);
        //then
        Assert.assertTrue(actual);
    }

    @Test
    public void containsNopeTest() {
        //given
        Integer [] numbers = {1, 3, 6, 15, 25};
        MySet<Integer> numSet = new MySet<>(numbers);
        //when
        boolean actual = numSet.contains(30);
        //then
        Assert.assertFalse(actual);
    }

    @Test
    public void sizeTest() {
        //given
        String [] wordies = {"I", "almost", "threw", "my", "computer", "out", "the", "window"};
        MySet<String> wordsSet = new MySet<>(wordies);
        wordsSet.add("but");
        wordsSet.add("nah");
        int expected = 10;
        //when
        int actual = wordsSet.size();
        //then
        Assert.assertEquals(expected, actual);
    }



}